*******************
* DOSEQUATES.ASM  *
*******************


*********** DOS LIBRARY ROUTINE OFFSETS  ******************


_LVOOpen          EQU   -30           ; (name, AccessMode)   (d1, d2)
_LVOClose         EQU   -36           ; (file)   (d1)
_LVORead          EQU   -42           ; (file, buf, len)   (d1, d2, d3)
_LVOWrite         EQU   -48           ; (file, buf, len)	(d1, d2, d3)
_LVOInput         EQU   -54           ; ()
_LVOOutput        EQU   -60           ; ()
_LVOSeek          EQU   -66           ; (file, pos, offset)  (d1, d2, d3)
_LVODeleteFile    EQU   -72           ; (name)   (d1)
_LVORename        EQU   -78           ; (OldName, NewName)   (d1, d2)
_LVOLock          EQU   -84           ; (name, access_mode)   (d1, d2)
_LVOUnLock        EQU   -90           ; (lock)   (d1)
_LVODupLock       EQU   -96           ; (lock)   (d1)
_LVOExamine       EQU   -102          ; (lock, FileInfoBlock)   (d1, d2)
_LVOExNext        EQU   -108          ; (lock, FileInfoBlock)   (d1, d2)
_LVOInfo          EQU   -114          ; (lock, ParamBlock)   (d1, d2)
_LVOCreateDir     EQU   -120          ; (name)   (d1)
_LVOCurrentDir    EQU   -126          ; (lock)   (d1)
_LVOIoErr         EQU   -132          ; ()
_LVOCreateProc    EQU   -138          ; (name,Pri,SegList,Stacksize) (d1,d2,d3,d4)
_LVOExit          EQU   -144          ; (returnCode)   (d1)
_LVOLoadSeg       EQU   -150          ; (Filename)   (d1)
_LVOUnLoadSeg     EQU   -156          ; (segment)   (d1)
_LVOGetPacket     EQU   -162          ; (wait)   (d1)
_LVOQueuePacket   EQU   -168          ; (packet)   (d1)
_LVODeviceProc    EQU   -174          ; (name)   (d1)
_LVOSetComment    EQU   -180          ; (name, comment)   (d1, d2)
_LVOSetProtection EQU   -186          ; (name, mask)   (d1, d2)
_LVODateStamp     EQU   -192          ; (date)   (d1)
_LVODelay         EQU   -198          ; (timeout)   (d1)
_LVOWaitForChar   EQU   -204          ; (file, timeout)  (d1, d2)
_LVOParentDir     EQU   -210          ; (lock)   (d1)
_LVOIsInteractive EQU   -216          ; (file)   (d1)
_LVOExecute       EQU   -222          ; (string, file, file)    (d1, d2, d3)


MODE_NEWFILE      EQU   1006
MODE_OLDFILE      EQU   1005
MODE_READONLY     EQU   1005
MODE_READWRITE    EQU   1004

ACCESS_READ	     EQU   -2
SHARED_LOCK	     EQU   -2
EXCLUSIVE_LOCK    EQU   -1
ACCESS_WRITE	     EQU   -1

fh_Type           EQU   8

****** PROCESS STRUCTURE OFFSETS

pr_CLI          EQU   $AC
pr_ConsoleTask  EQU   $A4
pr_MsgPort      EQU   $5C
pr_StackBase    EQU   $90
pr_StackSize    EQU   $84
pr_Task         EQU   $0
pr_TaskNum      EQU   $8C
pr_WindowPtr    EQU   $B8

TicksPerSecond    EQU   50

****** FileInfoBlock STRUCTURE OFFSETS

fib_DiskKey       EQU   0
fib_DirEntryType  EQU   4             ; Type of Dir. If <0 then file >0 = dir
fib_FileName      EQU   8             ; Null terminated. Max 30 of 108 chars use
fib_Protection    EQU   116           ; bit mask of protection, hsparwed are 7-0.      
fib_EntryType     EQU   120           ;
fib_Size          EQU   124           ; Number of bytes in file 
fib_NumBlocks     EQU   128           ; Number of blocks in file 
fib_DateStamp     EQU   132           ; Date file last changed. (12 bytes)
fib_Comment       EQU   144           ; Null terminated. 80 chars of 116 used now
fib_SIZEOF        EQU   260           ; SIZEOF FileInfoBlock Structure


* returned by Info() 

****** STRUCTURE  InfoData  Offsets=0  *******


id_NumSoftErrors  EQU   0             ; number of soft errors on disk 
id_UnitNumber     EQU   4             ; Which unit disk is (was) mounted on 
id_DiskState      EQU   8             ; See defines below 
id_NumBlocks      EQU   12            ; Number of blocks on disk 
id_NumBlocksUsed  EQU   16            ; Number of block in use 
id_BytesPerBlock  EQU   20
id_DiskType       EQU   24            ; Disk Type code
id_VolumeNode     EQU   28            ; BCPL pointer to volume node
id_InUse          EQU   32            ; Flag, zero if not in use
id_SIZEOF         EQU   36            ; SIZEOF InfoData Structure 

